-- # Script Cinemythics # --
-- # 1.0.3 # --


-- ----------------------------------------------------------------------------

SET SQL DIALECT 3;

CREATE DOMAIN D_BOX_MONEY AS
VARCHAR(20) CHARACTER SET NONE
COLLATE NONE;

CREATE SEQUENCE BOX_ID;
ALTER SEQUENCE BOX_ID RESTART WITH 0;



CREATE TABLE BOXOFFICE (
    NUMBOX   INTEGER NOT NULL,
    NUMFILM  INTEGER NOT NULL,
    BUDGET   BIGINT,
    RECETTE  BIGINT,
    ENTREE   BIGINT,
    RORO     D_BOX_MONEY /* D_BOX_MONEY = VARCHAR(20) */
);




ALTER TABLE BOXOFFICE ADD CONSTRAINT PK_BOXOFFICE PRIMARY KEY (NUMBOX)
USING INDEX IDX_PK_BOXOFFICE;



ALTER TABLE BOXOFFICE ADD CONSTRAINT FK_BOXOFFICE_FILM FOREIGN KEY (NUMFILM) REFERENCES FILM (NUMFILM)
  USING INDEX IDX_FK_BOX_FILM;


CREATE UNIQUE INDEX IDX_BOX_NUMFILM ON BOXOFFICE (NUMFILM);



-- Privileges of roles */
GRANT ALL ON BOXOFFICE TO ADMINCINE;



CREATE OR ALTER PROCEDURE I_BOX_NEW (
    numfilm integer)
returns (
    numbox integer)
as
declare variable new_id integer;
begin
  /* Procedure Text */
   new_id = gen_id(box_id, 1);
  insert into BOXOFFICE (numbox, numfilm)
  values(:new_id, :numfilm);
  numbox = new_id;
  suspend;
end;


CREATE OR ALTER TRIGGER TR_BOX_BI FOR BOXOFFICE
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  /* Trigger text */
   if (New.NumBox is NULL) then
   NEW.NumBox = gen_id(box_id, 1);
end;

CREATE OR ALTER TRIGGER TR_FILM_BD FOR FILM
ACTIVE BEFORE DELETE POSITION 0
AS
begin 
/* Trigger text */
/*--Table Acteur  */ 
Delete from Acteur where NumFilm = old.numfilm ;
/*--Table Realisateur */
Delete from Realisateur where NumFilm = old.numfilm ;
--Table Musicien
Delete from Musicien where NumFilm = old.numfilm ;
--Table Scenariste
Delete from Scenariste where NumFilm = old.numfilm;
--Table Dialoguiste
Delete from Dialoguiste where NumFilm = old.numfilm ;
--Table Producteur
Delete from Producteur where NumFilm = old.numfilm ;
--Table Distri_Film 
Delete from Distri_Film where NumFilm = old.numfilm ;
--Table Tech_Metier_Film
Delete from Tech_Metier_Film where NumFilm = old.numfilm ;
--Table Tag_Film
Delete from Tag_Film where NumFilm = old.numfilm ;
--Les Multimedia
Delete from Multimedia where NumXtra in (
select NumXtra from Xtra_Mvi where NumFilm = old.numfilm );
--Les Autres Titres
Delete from Autre_Titre where NumFilm = old.numfilm;
--Les Box Office
Delete from BOXOFFICE where NumFilm = old.numfilm;
end;



GRANT INSERT ON BOXOFFICE TO PROCEDURE I_BOX_NEW;

GRANT EXECUTE ON PROCEDURE I_BOX_NEW TO aDMINCINE;




-- Insertion des valeurs dans version_base
insert into VERSION_BASE(NUM_VERSION, SCRIPT_MODIF) values (
'2.0.1',
'SET SQL DIALECT 3;

CREATE DOMAIN D_BOX_MONEY AS
VARCHAR(20) CHARACTER SET NONE
COLLATE NONE;

CREATE SEQUENCE BOX_ID;
ALTER SEQUENCE BOX_ID RESTART WITH 0;



CREATE TABLE BOXOFFICE (
    NUMBOX   INTEGER NOT NULL,
    NUMFILM  INTEGER NOT NULL,
    BUDGET   BIGINT,
    RECETTE  BIGINT,
    ENTREE   BIGINT,
    RORO     D_BOX_MONEY /* D_BOX_MONEY = VARCHAR(20) */
);




ALTER TABLE BOXOFFICE ADD CONSTRAINT PK_BOXOFFICE PRIMARY KEY (NUMBOX)
USING INDEX IDX_PK_BOXOFFICE;



ALTER TABLE BOXOFFICE ADD CONSTRAINT FK_BOXOFFICE_FILM FOREIGN KEY (NUMFILM) REFERENCES FILM (NUMFILM)
  USING INDEX IDX_FK_BOX_FILM;


CREATE UNIQUE INDEX IDX_BOX_NUMFILM ON BOXOFFICE (NUMFILM);



-- Privileges of roles */
GRANT ALL ON BOXOFFICE TO ADMINCINE;



CREATE OR ALTER PROCEDURE I_BOX_NEW (
    numfilm integer)
returns (
    numbox integer)
as
declare variable new_id integer;
begin
  /* Procedure Text */
   new_id = gen_id(box_id, 1);
  insert into BOXOFFICE (numbox, numfilm)
  values(:new_id, :numfilm);
  numbox = new_id;
  suspend;
end;




CREATE OR ALTER TRIGGER TR_BOX_BI FOR BOXOFFICE
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  /* Trigger text */
   if (New.NumBox is NULL) then
   NEW.NumBox = gen_id(box_id, 1);
end;


CREATE OR ALTER TRIGGER TR_FILM_BD FOR FILM
ACTIVE BEFORE DELETE POSITION 0
AS
begin 
/* Trigger text */
/*--Table Acteur  */ 
Delete from Acteur where NumFilm = old.numfilm ;
/*--Table Realisateur */
Delete from Realisateur where NumFilm = old.numfilm ;
--Table Musicien
Delete from Musicien where NumFilm = old.numfilm ;
--Table Scenariste
Delete from Scenariste where NumFilm = old.numfilm;
--Table Dialoguiste
Delete from Dialoguiste where NumFilm = old.numfilm ;
--Table Producteur
Delete from Producteur where NumFilm = old.numfilm ;
--Table Distri_Film 
Delete from Distri_Film where NumFilm = old.numfilm ;
--Table Tech_Metier_Film
Delete from Tech_Metier_Film where NumFilm = old.numfilm ;
--Table Tag_Film
Delete from Tag_Film where NumFilm = old.numfilm ;
--Les Multimedia
Delete from Multimedia where NumXtra in (
select NumXtra from Xtra_Mvi where NumFilm = old.numfilm );
--Les Autres Titres
Delete from Autre_Titre where NumFilm = old.numfilm;
--Les Box Office
Delete from BOXOFFICE where NumFilm = old.numfilm;
end;

GRANT INSERT ON BOXOFFICE TO PROCEDURE I_BOX_NEW;

GRANT EXECUTE ON PROCEDURE I_BOX_NEW TO aDMINCINE;'
);