-- # Script Cinemythics # --
-- # 2.0.4 # --


-- ----------------------------------------------------------------------------

SET SQL DIALECT 3;

-- Ajout Champ NBJ Table Gens

ALTER TABLE GENS
	ADD NBJ INTEGER;

CREATE INDEX IDX_GENS_NBJ ON GENS (NBJ);

/* View: TEMPLISTEGENS */
CREATE VIEW TEMPLISTEGENS(
    NUMGENS,
    ALIAS,
    DATA,
    DATE_N,
    DATE_M,
    NBJ)
AS
select G.NUMGENS, G.ALIAS, G.DATA, G.DATE_N, G.DATE_M, G.NBJ from GENS G
order by cvrascii(lower(G.alias));


GRANT ALL ON TEMPLISTEGENS TO ADMINCINE;

-- Table Temp1

CREATE TABLE TEMP1 (
    NUMGENS  INTEGER,
    NBJ      BIGINT
);

CREATE INDEX TEMP1_IDX1 ON TEMP1 (NUMGENS);

--insertion Donne dans #TEMP1

insert into temp1
select G.NUMGENS, sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null ) H

on G.alias = H.alias

group by G.NUMGENS;

--Update de la table Gens

update gens G
set G.NBJ = (select NBJ from temp1 T
                where T.numgens = G.numgens );

--creation Procedure U_GENS_NBJ
CREATE OR ALTER PROCEDURE U_GENS_NBJ (
    id_numgens integer)
as
begin
  /* Procedure Text */
  UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = :ID_NUMGENS

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = :ID_NUMGENS

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = :ID_NUMGENS       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = :ID_NUMGENS )

where G.numgens = :ID_NUMGENS;
end;



GRANT SELECT,UPDATE ON GENS TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON ACTEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON REALISATEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON DIALOGUISTE TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON PRODUCTEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON SCENARISTE TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON MUSICIEN TO PROCEDURE U_GENS_NBJ;

GRANT EXECUTE ON PROCEDURE U_GENS_NBJ TO SYSDBA;

GRANT EXECUTE ON PROCEDURE U_GENS_NBJ TO ADMINCINE;

--Effacement table temporaire
DROP TABLE TEMP1;

--Modification Table Film
ALTER TABLE FILM
 ADD THE_SOUNDEX  D_FILM_TITRE;

--Modification Table AUTRE_TITRE
ALTER TABLE AUTRE_TITRE
  ADD  THE_SOUNDEX  D_FILM_TITRE;

--Creation Table Temporaire

CREATE TABLE TEMP1 (
    NUMFILM      INTEGER,
    THE_SOUNDEX  D_FILM_TITRE /* D_FILM_TITRE = VARCHAR(100) */,
    TITRE        D_FILM_TITRE /* D_FILM_TITRE = VARCHAR(100) */
);

-- Modification I_Film_New
CREATE OR ALTER PROCEDURE I_FILM_NEW (
    titre d_film_titre,
    the_soundex d_film_titre)
returns (
    numfilm integer)
as
declare variable new_id integer;
begin
  /* Procedure Text */
  new_id = gen_id(film_id, 1);
  insert into film (numfilm,  Titre, The_Soundex)
  values(:New_ID, :titre, :The_Soundex);
  numfilm = New_Id;
  suspend;
end; 

GRANT INSERT ON FILM TO PROCEDURE I_FILM_NEW;

GRANT EXECUTE ON PROCEDURE I_FILM_NEW TO SYSDBA;
GRANT EXECUTE ON PROCEDURE I_FILM_NEW TO ADMINCINE;



/******************************************************************************/
/*                                  Indices                                   */
/******************************************************************************/

CREATE INDEX TEMP1_IDX1 ON TEMP1 (NUMFILM);
CREATE INDEX TEMP1_IDX2 ON TEMP1 (THE_SOUNDEX);
CREATE INDEX TEMP1_IDX3 ON TEMP1 (TITRE);


/******************************************************************************/
/*                                 Privileges                                 */
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON TEMP1 TO ADMINCINE;


/*******************************************************************************/
/*		Les Triggers															*/
/*******************************************************************************/

--TR_ACTEUR_AD

CREATE OR ALTER TRIGGER TR_ACTEUR_AD FOR ACTEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;


-- TR_REALISATEUR_AD
CREATE OR ALTER TRIGGER TR_REALISATEUR_AD FOR REALISATEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_MUSICIEN_AD
CREATE OR ALTER TRIGGER TR_MUSICIEN_AD FOR MUSICIEN
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_PRODUCTEUR_AD
CREATE OR ALTER TRIGGER TR_PRODUCTEUR_AD FOR PRODUCTEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_SCENARISTE_AD

CREATE OR ALTER TRIGGER TR_SCENARISTE_AD FOR SCENARISTE
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_DIALOGUISTE_AD
CREATE OR ALTER TRIGGER TR_DIALOGUISTE_AD FOR DIALOGUISTE
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;






/*******************************************************************************/
/*		Insertion des scripts dans version_base									*/
/*******************************************************************************/

insert into VERSION_BASE(NUM_VERSION, SCRIPT_MODIF) values (
'2.0.5',
'
SET SQL DIALECT 3;

-- Ajout Champ NBJ Table Gens

ALTER TABLE GENS
	ADD NBJ INTEGER;

CREATE INDEX IDX_GENS_NBJ ON GENS (NBJ);

/* View: TEMPLISTEGENS */
CREATE VIEW TEMPLISTEGENS(
    NUMGENS,
    ALIAS,
    DATA,
    DATE_N,
    DATE_M,
    NBJ)
AS
select G.NUMGENS, G.ALIAS, G.DATA, G.DATE_N, G.DATE_M, G.NBJ from GENS G
order by cvrascii(lower(G.alias));


GRANT ALL ON TEMPLISTEGENS TO ADMINCINE;

-- Table Temp1

CREATE TABLE TEMP1 (
    NUMGENS  INTEGER,
    NBJ      BIGINT
);

CREATE INDEX TEMP1_IDX1 ON TEMP1 (NUMGENS);

--insertion Donne dans #TEMP1

insert into temp1
select G.NUMGENS, sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null ) H

on G.alias = H.alias

group by G.NUMGENS;

--Update de la table Gens

update gens G
set G.NBJ = (select NBJ from temp1 T
                where T.numgens = G.numgens );

--creation Procedure U_GENS_NBJ
CREATE OR ALTER PROCEDURE U_GENS_NBJ (
    id_numgens integer)
as
begin
  /* Procedure Text */
  UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = :ID_NUMGENS

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = :ID_NUMGENS

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = :ID_NUMGENS

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = :ID_NUMGENS       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = :ID_NUMGENS )

where G.numgens = :ID_NUMGENS;
end;



GRANT SELECT,UPDATE ON GENS TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON ACTEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON REALISATEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON DIALOGUISTE TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON PRODUCTEUR TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON SCENARISTE TO PROCEDURE U_GENS_NBJ;

GRANT SELECT ON MUSICIEN TO PROCEDURE U_GENS_NBJ;

GRANT EXECUTE ON PROCEDURE U_GENS_NBJ TO SYSDBA;

GRANT EXECUTE ON PROCEDURE U_GENS_NBJ TO ADMINCINE;

--Effacement table temporaire
DROP TABLE TEMP1;

--Modification Table Film
ALTER TABLE FILM
 ADD THE_SOUNDEX  D_FILM_TITRE;

--Modification Table AUTRE_TITRE
ALTER TABLE AUTRE_TITRE
  ADD  THE_SOUNDEX  D_FILM_TITRE;

--Creation Table Temporaire

CREATE TABLE TEMP1 (
    NUMFILM      INTEGER,
    THE_SOUNDEX  D_FILM_TITRE /* D_FILM_TITRE = VARCHAR(100) */,
    TITRE        D_FILM_TITRE /* D_FILM_TITRE = VARCHAR(100) */
);

-- Modification I_Film_New
CREATE OR ALTER PROCEDURE I_FILM_NEW (
    titre d_film_titre,
    the_soundex d_film_titre)
returns (
    numfilm integer)
as
declare variable new_id integer;
begin
  /* Procedure Text */
  new_id = gen_id(film_id, 1);
  insert into film (numfilm,  Titre, The_Soundex)
  values(:New_ID, :titre, :The_Soundex);
  numfilm = New_Id;
  suspend;
end; 

GRANT INSERT ON FILM TO PROCEDURE I_FILM_NEW;

GRANT EXECUTE ON PROCEDURE I_FILM_NEW TO SYSDBA;
GRANT EXECUTE ON PROCEDURE I_FILM_NEW TO ADMINCINE;



/******************************************************************************/
/*                                  Indices                                   */
/******************************************************************************/

CREATE INDEX TEMP1_IDX1 ON TEMP1 (NUMFILM);
CREATE INDEX TEMP1_IDX2 ON TEMP1 (THE_SOUNDEX);
CREATE INDEX TEMP1_IDX3 ON TEMP1 (TITRE);


/******************************************************************************/
/*                                 Privileges                                 */
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON TEMP1 TO ADMINCINE;


/*******************************************************************************/
/*		Les Triggers															*/
/*******************************************************************************/

--TR_ACTEUR_AD

CREATE OR ALTER TRIGGER TR_ACTEUR_AD FOR ACTEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;


-- TR_REALISATEUR_AD
CREATE OR ALTER TRIGGER TR_REALISATEUR_AD FOR REALISATEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_MUSICIEN_AD
CREATE OR ALTER TRIGGER TR_MUSICIEN_AD FOR MUSICIEN
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_PRODUCTEUR_AD
CREATE OR ALTER TRIGGER TR_PRODUCTEUR_AD FOR PRODUCTEUR
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_SCENARISTE_AD

CREATE OR ALTER TRIGGER TR_SCENARISTE_AD FOR SCENARISTE
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;

--TR_DIALOGUISTE_AD
CREATE OR ALTER TRIGGER TR_DIALOGUISTE_AD FOR DIALOGUISTE
ACTIVE AFTER DELETE POSITION 0
AS
begin
  /* Trigger text */
   UPDATE gens G
  set G.NBJ = (select sum(H.TT) NBJ from GENS G

right join (
select distinct alias, numfilm, TT from (
select alias, A.numfilm, 1 TT from Gens G
left join Acteur A
on A.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, B.numfilm,1 TT from Gens G
left join realisateur B
on B.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, C.numfilm, 1 TT from Gens G
left join dialoguiste C
on C.numgens = G.numgens
where G.numgens = old.numgens

union 
select alias, D.numfilm, 1 TT from Gens G
left join producteur D
on D.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, E.numfilm, 1 TT from Gens G
left join scenariste E
on E.numgens = G.numgens 
where G.numgens = old.numgens

union 
select alias, F.numfilm, 1 TT from Gens G
left join musicien F
on F.numgens = G.numgens
where G.numgens = old.numgens       )

--group by alias
--having sum(tt) > 9
where numfilm is not null


-- order by sum(tt) desc ) E
                          ) H
on G.alias = H.alias
where G.numgens = old.numgens )

where G.numgens = old.numgens;
end;


'
);